<template>
  <span>
    <v-list-item
      v-for="(key, index) in Object.keys(SERVICES)"
      :key="index"
      icon
      dense
      :disabled="isLoading"
      @click="() => sendRequest(SERVICES[key])"
    >
      <v-list-item-icon>
        <v-icon v-if="!isLoading">mdi-test-tube</v-icon>
        <v-icon v-else class="loading-icon">mdi-loading</v-icon>
      </v-list-item-icon>
      <v-list-item-title>
        [External] {{ key }}
      </v-list-item-title>
    </v-list-item>
  </span>
</template>

<script lang="ts">
import type { Client } from '@/client';
import type { Analysis } from '@/data';
import type { AnalysisFormat } from '@/formats/analysis-formats';
import AnalysisParser from '@/formats/AnalysisParser';
import { Component, Prop, Vue } from 'vue-property-decorator';

@Component({})
export default class AnalysisExternalServices extends Vue {
  @Prop({ required: true })
  client!: Client;

  @Prop({ required: true })
  analysis!: Analysis;

  @Prop({ required: true })
  piecePath!: string;

  isLoading = false;

  SERVICES: Record<string, string> = {
    // 'All Positive': 'http://51.75.16.231/analysis/positive',
    // 'All Negative': 'http://51.75.16.231/analysis/negative',
    // 'Add Feedback': 'http://51.75.16.231/analysis/addFeedback',
    // 'Feedback (5s)': 'http://51.75.16.231/analysis/long',
    // 'Feedback (30s - Timeout)': 'http://51.75.16.231/analysis/timeout',
  };

  async sendRequest(url: string) {
    try {
      this.isLoading = true;
      this.$store.dispatch('updateLockEditor', true);
      const formData = new FormData();

      const piecePathSplit = this.piecePath.split('/');
      const pieceId = piecePathSplit[piecePathSplit.length - 1];
      const score = await this.client.get(`${this.client.baseUrl}static/resources/${this.piecePath}/originals/0-${pieceId}.xml`);

      if (score) {
        formData.append('score', new File([
          score.data as Blob,
        ], 'score.xml', { type: 'text/plain' }));
      }
      formData.append('analysis', new File(
        [
          JSON.stringify(
            AnalysisParser.exportFormat(this.analysis),
            null,
            2,
          ),
        ],
        this.analysis.fileName || 'analysis.dez',
        { type: 'text/plain' },
      ));
      const { data } = await this.client.post(url, formData, {
        headers: {
          'Content-Type': 'multipart/form-data',
        },
      });
      this.updateCurrentAnalysis(data as AnalysisFormat);
    } catch (error) {
      this.isLoading = false;
      this.$store.dispatch('updateLockEditor', false);
      throw error;
    }
  }

  updateCurrentAnalysis(rawAnalysis: AnalysisFormat) {
    const analysis: Analysis = AnalysisParser.parseFormat(rawAnalysis);
    this.$emit('replace-analysis', analysis);
    this.isLoading = false;
    this.$store.dispatch('updateLockEditor', false);
  }
}
</script>

<style lang="scss" coped>
@keyframes rotating {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}
.loading-icon {
  animation: rotating 2s linear infinite;
}
</style>
